#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>

#include "IL\il.h"
#include "IL\ilu.h"

#pragma comment(lib,"msvcrt.lib")
#pragma comment(lib,"lib\\devil.lib")
#pragma comment(lib,"lib\\ilu.lib")
#pragma comment(lib,"user32.lib")
#pragma comment(linker,"/nod:libc /align:4096 /release /opt:ref")


int level = 4096;

unsigned char LimScale(char * a, unsigned int l, unsigned int * w, unsigned int * h)
{
	 unsigned char r = 0;
	 if (strstr((char*)a,"terrain_")) l = 512, printf("T ");
	 else if (strstr((char*)a,"detail_")) l = 512, printf("D ");
	 else if (strstr((char*)a,"lmap#")) l = 512, printf("L ");

	 for (;;)
	 {
	 if ((*w <= l) && (*h <= l)) break;
	  *w >>= 1; *h >>= 1; r = 1;
	  }
    return r;
}

WIN32_FIND_DATA fd32;
HANDLE fh = 0;
char sarg[100];
bool rest;
unsigned char sl;
unsigned int iw, ih, ib, dxtf, nm;

#ifdef WIN32
static LARGE_INTEGER FPSCount0={0,0}, FPSCount1={0,0};
static LARGE_INTEGER CounterFrequency={0,0};
#endif

int main(int argc, char *argv[])
{
if (argc < 2)
{
printf("DESCALE [201212xx]: no arguments given.\n");
printf("usage: descale.exe <level>\n");
printf("\tlevel can be 4096, 2048, 1024, 512, 256, 128, 64, 32, 16, 8, 4, 2\n");
}
else
level = atoi(argv[1]);

printf("level is now : %u\n", level);

#ifdef WIN32
	DWORD PriorityClass = GetPriorityClass(GetCurrentProcess());
	SetPriorityClass(GetCurrentProcess(),HIGH_PRIORITY_CLASS); // REALTIME_PRIORITY_CLASS
	QueryPerformanceFrequency(&CounterFrequency);
	QueryPerformanceCounter(&FPSCount0);
#endif
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);
	ilInit();
 	iluInit();
	ilSetInteger(IL_KEEP_DXTC_DATA, IL_TRUE);
	ilEnable(IL_FILE_OVERWRITE);
  iluImageParameter(ILU_FILTER,ILU_BILINEAR); // or ILU_LINEAR

	lstrcpy(sarg,"*.dds");

	fh = FindFirstFile(sarg,&fd32);
	if (fh != INVALID_HANDLE_VALUE) rest = 1;
	while (rest)
	{
		if (!(fd32.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
		{
		sl = strlen(fd32.cFileName);
		printf("found '%s' ",fd32.cFileName);
		//printf("*"); _getch();
		ilLoadImage(fd32.cFileName);
		//printf("*"); _getch();
		iw = ilGetInteger(IL_IMAGE_WIDTH);
		ih = ilGetInteger(IL_IMAGE_HEIGHT);
		dxtf = ilGetInteger (IL_DXTC_DATA_FORMAT);
		nm = ilGetInteger(IL_NUM_MIPMAPS);

		ib = ilGetInteger(IL_IMAGE_BPP);
		printf("%ux%u %u bpp (0x%04X) %u, ",iw, ih, ib << 3, dxtf, nm);
		if (strstr(fd32.cFileName,"_bump.") || strstr(fd32.cFileName,"_bump#.") || strstr(fd32.cFileName,"sky_"))
		{
  	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),FOREGROUND_INTENSITY | FOREGROUND_RED);
		printf("skipped\n");
		}
		else
		{
	 	if (LimScale((char*)fd32.cFileName,level,&iw,&ih)) 
	 	{
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),FOREGROUND_INTENSITY | FOREGROUND_GREEN);
		if  (dxtf == IL_DXT_NO_COMP) dxtf = IL_DXT1; // to default
		ilSetInteger(IL_DXTC_FORMAT, dxtf);
		iluScale(iw,ih,ib);
    fd32.cFileName[sl-1] = '$';
		ilSave(IL_TGA,fd32.cFileName); ilLoadImage(fd32.cFileName); // fake save-load :)
		ilSave(IL_DDS,fd32.cFileName); 
		printf("saved as %ux%u\n", iw, ih);
		}
		else
  	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),FOREGROUND_INTENSITY | FOREGROUND_GREEN | FOREGROUND_RED),
		printf("untouched\n");
		}
		}
		SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);
		if (!FindNextFile(fh,&fd32))
			rest = FALSE;
	}
	FindClose(fh);
  ilShutDown();
#ifdef WIN32
		QueryPerformanceCounter(&FPSCount1);
    printf("_MSC_VER=%u, %2.4f sec ", _MSC_VER, (float)(FPSCount1.QuadPart-FPSCount0.QuadPart)/CounterFrequency.QuadPart);
    printf("%6.4f ms\n", (float)(((FPSCount1.QuadPart-FPSCount0.QuadPart)*1000.0)/CounterFrequency.QuadPart));
//    printf("before %u after %u diff %u, freq %u\n",
//		(unsigned int)FPSCount0.QuadPart, (unsigned int)FPSCount1.QuadPart, (unsigned int)(FPSCount1.QuadPart-FPSCount0.QuadPart), (unsigned int)CounterFrequency.QuadPart);
#endif
	return 0;
}